// Simple framework for Macintosh sample code
//
// David Hayward and Nick Thompson 
// Developer Technical Support
// AppleLink: DEVSUPPORT
//
// Copyrite 1995, Apple Computer,Inc
//
// Simple error handling code, based on sample code by smd
// 
// 9/16/94	nick	first cut

#include <AppleEvents.h>
#include <Dialogs.h>
#include <OSUtils.h>
#include <ToolUtils.h>
#include <SegLoad.h>
#include <TextUtils.h>

#include "appMain.h"
#include "ErrorHandling.h"


//----------------------------------------------------------------------------------
//  If an error has occurred, I check the user interaction level. If I can			
//	interact with the user, I put up a dialog and exit the application; otherwise,
//	I just exit the application.
//
//	***NOTE: Real applications would not handle errors in this fashion!  If they
//	cannot interact with the user, they should abort the Apple event handler and
// return the error in the reply parameter.

void FailIfErr (OSErr  error)
{
	if (error)
	{
//		if (!(AEInteractWithUser(kNoTimeOut, nil, nil)))			// Can we interact?
			AlertUser(error);										// Yes, so put up the dialog.
		ExitToShell();
	}
}

//----------------------------------------------------------------------------------
// Display an alert for the user to indicate that an error has occurred.

void AlertUser ( short error )
{
	short		itemHit, index ;
	Str255		message ;
	Str255		errNo ;

	index = error ;
	if( error < 0 )
		index = eGenericError ;

	GetIndString(message, rErrorStringIndex, index);
	
	NumToString( error, errNo ) ;
	
	ParamText(	message,
				(ConstStr255Param)"\p (",
				errNo,
				(ConstStr255Param)"\p).");	// [pwpc]

	itemHit = Alert(rUserAlert, nil);
}

//----------------------------------------------------------------------------------

void FatalError ( short error )
{
	Str255		message ;

	GetIndString(message, rErrorStringIndex, error);

	ParamText(	message,
				(ConstStr255Param)"\p",
				(ConstStr255Param)"\p",
				(ConstStr255Param)"\p");	// [pwpc]

	(void)StopAlert( rFatalAlert, nil ) ;
	ExitToShell() ;
}