// Simple framework for Macintosh sample code
//
// David Hayward and Nick Thompson 
// Developer Technical Support
// AppleLink: DEVSUPPORT
//
// Copyrite 1995, Apple Computer,Inc
//
// This file contains the AppleEvent handler routines.
// 
// 9/16/94	nick	first cut
// 11/16/94	david	added a global gAE_available to aeGlobals.c
//					changeg AE_available to set/clear the global


#include <AppleEvents.h>

#include "aeGlobals.h"
#include "aeUtils.h"
#include "aeHandlers.h"

#include "appAEHandlers.h"



/*------------------------------------------------------------------------------*\
	HandleOAPP
 *------------------------------------------------------------------------------*
		This routine processes the 'OAPP' AppleEvent
		and passes it to the framework.
\*------------------------------------------------------------------------------*/
pascal OSErr HandleOAPP ( AppleEvent *theAppleEvent, AppleEvent *reply, long refCon )
{
	OSErr err;

	err = MyGotRequiredParams(theAppleEvent);

	if (err == noErr)				
		err = appHandleOAPP();

	return err;
}


/*------------------------------------------------------------------------------*\
	HandleODOC
 *------------------------------------------------------------------------------*
		This routine processes the 'ODOC' AppleEvent
		and passes it to the framework.
\*------------------------------------------------------------------------------*/
pascal OSErr HandleODOC ( AppleEvent *theAppleEvent, AppleEvent *reply, long refCon )
{
	FSSpec 		myFSS;
	AEDescList	docList;
	OSErr		err,
				ignoreErr;
	long		index,
				itemsInList;
	Size 		actualSize;
	AEKeyword	keywd;
	DescType	returnedType;
	
	err = AEGetParamDesc(theAppleEvent, keyDirectObject, typeAEList, &docList );
	if (err == noErr)
	{
		// check for missing required parameters
		err = MyGotRequiredParams(theAppleEvent);
		if (err == noErr)
		{
			// see how many descriptor items are in the list
			// this is the number of documents we want to open
			err = AECountItems(&docList,&itemsInList);
	
			// now get each descriptor record from the list
			// coerce the returned data to an FSSpec record, and
			// open the asoociated file
			
			for (index=1; index <= itemsInList && err == noErr; index++)
			{
				err = AEGetNthPtr(	&docList, 
									index,
									typeFSS,
									&keywd,
									&returnedType,
									(Ptr)&myFSS,
									sizeof(myFSS),
									&actualSize);
		
				if (err == noErr)					
					err = appHandleODOC( &myFSS );
			}
		}
		ignoreErr = AEDisposeDesc(&docList);
	}
	return err ;
}


/*------------------------------------------------------------------------------*\
	HandlePDOC
 *------------------------------------------------------------------------------*
		This routine processes the 'PDOC' AppleEvent
		and passes it to the framework.
\*------------------------------------------------------------------------------*/
pascal OSErr HandlePDOC ( AppleEvent *theAppleEvent, AppleEvent *reply, long refCon )
{
	FSSpec 		myFSS;
	AEDescList	docList;
	OSErr		err;
	long		index,
				itemsInList;
	Size 		actualSize;
	AEKeyword	keywd;
	DescType	returnedType;
	
	err = AEGetParamDesc(theAppleEvent,keyDirectObject,typeAEList,&docList);
	if (err == noErr) {
	
		// check for missing required parameters
		err = MyGotRequiredParams(theAppleEvent);
		if (err == noErr)
		{
			// see how many descriptor items are in the list
			// this is the number of documents we want to open
			err = AECountItems(&docList,&itemsInList);
	
			// now get each descriptor record from the list
			// coerce the returned data to an FSSpec record, and
			// open the asoociated file
			
			for (index=1; index <= itemsInList && err == noErr; index++)
			{
				err = AEGetNthPtr(	&docList, 
									index,
									typeFSS,
									&keywd,
									&returnedType,
									(Ptr)&myFSS,
									sizeof(myFSS),
									&actualSize);
				if (err == noErr)				
					err = appHandlePDOC( &myFSS );
			}
		}
		err = AEDisposeDesc(&docList);
	}
	return err ;
}


/*------------------------------------------------------------------------------*\
	HandleQUIT
 *------------------------------------------------------------------------------*
		This routine processes the 'QUIT' AppleEvent
		and passes it to the framework.
\*------------------------------------------------------------------------------*/
pascal OSErr HandleQUIT ( AppleEvent *theAppleEvent, AppleEvent *reply, long refCon )
{
	OSErr err;
	
	err = MyGotRequiredParams(theAppleEvent);

	if (err == noErr)				
		err = appHandleQUIT();

	if (err == noErr)				
  		AEDisposeDesc(&gSelfAddress);			// Dispose of my self-addressed descriptor.

	return err;
}

