
#ifndef _CURSORSTUFF_
#define _CURSORSTUFF_


/**\
|**| ==============================================================================
|**| PUBLIC DEFINES
|**| ==============================================================================
\**/
#define kMaxNumCursors		20		// Max number of spinning cursors we	
									// allocate space for.					
#define kMinCursorTicks		10		// Min number of ticks that must pass	
									// between spinning cursor changes.		
#define kArrowCursor		0		// Pseudo resource ID for arrow cursor	
									// which is actually a QD global.  We	
									// use this in TearDownCursors.			

/**\
|**| ==============================================================================
|**| PUBLIC TYPEDEFS
|**| ==============================================================================
\**/

/*------------------------------------------------------------------------------*\
	ACurRec
 *------------------------------------------------------------------------------*
		This is just a C structure that parallels the 'acur' animated cursor resource.
		The animated cursor routines use it.
\*------------------------------------------------------------------------------*/
typedef struct ACurRec {
       short	numCursors;		// Number of cursors.
       short	nextFrame;		// Next cursor to display.
       long		cursID[];		// IDs of crsr or CURS resources.
} ACurRec, *ACurPtr, **ACurHdl;


/**\
|**| ==============================================================================
|**| PUBLIC FUNCTION PROTOTYPES
|**| ==============================================================================
\**/
void SetUpCursors(short acurID, short finalCursorID) ;
void BumpCursor() ;
void TearDownCursors() ;


#endif