#include <Resources.h>
#include <Files.h>
#include <TextUtils.h>

#if 0
#include "MoreFilesExtras.h"
#endif
#include "fileStuff.h"

#define kDefaultTempFileName	"\pTempFile"


/**\
|**| ==============================================================================
|**| PRIVATE FUNCTION PROTOTYPES
|**| ==============================================================================
\**/
void pcat (StringPtr d, StringPtr s) ;



/**\
|**| ==============================================================================
|**| PUBLIC FUNCTIONS
|**| ==============================================================================
\**/


//---------------------------------------------------------------------
//	SameFSSpec checks to FSSpec records to see if they are the same.
//
Boolean	SameFSSpec(FSSpec *fs1, FSSpec *fs2)
{
	return ( (fs1->vRefNum == fs2->vRefNum) && 
			 (fs1->parID   == fs2->parID) && 
	       	 (EqualString(fs1->name,fs2->name, false, true)) );
}



#if 0
/*****************************************************************************/

static	OSErr	NewTempFile(const short vRefNum,
							const long alternateDirID,
							OSType creator,
							OSType fileType,
							Boolean openDataFork,
							Boolean openResourceFork,
							short *dataRefNum,
							short *resRefNum)
{
	OSErr	result;
	short	foundVRefNum;
	long	foundDirID;
	long	theTicks;
	short	overflow;
	Str255	tempFileName;
	
	*dataRefNum = 0;
	*resRefNum = 0;
	result = FindFolder(vRefNum, kTemporaryFolderType, kCreateFolder,
						&foundVRefNum, &foundDirID);
	if ( result == fnfErr )
	{
		/* If temporary items folder isn't available, then */
		/* use the alternate directory where the caller thinks we can write */
		foundVRefNum = vRefNum;
		foundDirID = alternateDirID;
	}
	
	/* Create a temporary file with a unique name */
	theTicks = TickCount();
	NumToString(theTicks, tempFileName);
	pcat(tempFileName, kDefaultTempFileName);
	overflow = 0;
	do
	{
		result = HCreate(foundVRefNum, foundDirID, tempFileName, creator, fileType);
		if ( result == dupFNErr )
		{
			++tempFileName[1];
			++overflow;
		}
	} while ( (result == dupFNErr) && (overflow < 256) );
	
	if ( result == noErr )
	{
		if ( openDataFork)
		{
			result = HOpenAware(foundVRefNum, foundDirID, tempFileName,
								dmRdWrDenyRdWr, dataRefNum);
		}
		
		if ( (result == noErr) && openResourceFork )
		{
			HCreateResFile(foundVRefNum, foundDirID, tempFileName);
			result = ResError();
			if ( result == noErr )
			{
				*resRefNum = HOpenResFile(foundVRefNum, foundDirID,
										  tempFileName, fsRdWrPerm);
				result = ResError();
			}
		}
		
		if ( result != noErr )
		{
			/* Attempt to delete the temp file if there is an error */
			if ( *dataRefNum != 0 )
				(void) FSClose(*dataRefNum);

			if ( *resRefNum != 0 )
				CloseResFile(*resRefNum);

			(void) HDelete(foundVRefNum, foundDirID, tempFileName);
		}
	}
	return ( result );
}

/*****************************************************************************/

static	OSErr	DisposeTempFile(short dataRefNum,
								short resRefNum)
{
	OSErr	result;
	short	vRefNum;
	long	dirID;
	Str255	fileName;
	
	/* Find out where the file is now */
	if ( dataRefNum != 0 )
		result = GetFileLocation(dataRefNum, &vRefNum, &dirID, fileName);
	else
		result = GetFileLocation(resRefNum, &vRefNum, &dirID, fileName);

	if ( result == noErr )
	{
		/* Close the file(s) */
		if ( dataRefNum != 0 )
			(void) FSClose(dataRefNum);

		if ( resRefNum != 0 )
			CloseResFile(resRefNum);
		
		/* Delete the file */
		result = HDelete(vRefNum, dirID, fileName);
	}
	return ( result );
}



/**\
|**| ==============================================================================
|**| PRIVATE FUNCTIONS
|**| ==============================================================================
\**/

/*****************************************************************************/

static	void	pcat(StringPtr d, StringPtr s)
{
	short	i, j;

	if (((j = s[0]) + d[0]) > 255)
		j = 255 - d[0];
			/* Limit dest string to 255. */

	for (i = 0; i < j;) d[++d[0]] = s[++i];
}


#endif
