// A pict file window
//
// David Hayward 
// Developer Technical Support
// AppleLink: DEVSUPPORT
//
// Copyrite 1995, Apple Computer,Inc
//
// This file contains the menus routines for a pict file window.
// 
// 9/13/94	nick	first cut
// 12/13/94	david	several modifications


#include <StandardFile.h>

#include "appGlobals.h"
#include "appMenus.h"
#include "aeSenders.h"

#include "win.h"
#include "winPictDocMenus.h"
#include "winPictDocGetSet.h"

#include "gxGlobals.h"
#include "gxPrintUtils.h"
#include "qdPrintUtils.h"
#include "cursorStuff.h"
#include "pictStuff.h"


void winAdjustMenusPictDoc ( winHandle win ) 
{
	MenuHandle	theMenu ;
	Boolean		dirty ;
	
	dirty = GetWinDirty( win ) ;
	
	// do the file menu
	theMenu = GetMHandle ( mFile ) ;

		EnableItem ( theMenu, 0 );
		EnableItem ( theMenu, iClose );
		EnableItem ( theMenu, iSaveAs );
		EnableItem ( theMenu, iPageSetup );
		EnableItem ( theMenu, iPrint );
		EnableItem ( theMenu, iPrintOne );
		
		// for the next 2, check to see if the document has been changed
		if ( dirty )
		{
			EnableItem ( theMenu, iSave );
			EnableItem ( theMenu, iRevert );
		}

	// do the profiles menu
	theMenu = GetMHandle ( mProfiles ) ;

		EnableItem ( theMenu, 0 );
		
	DrawMenuBar() ;
}


void winSaveCmndPictDoc ( winHandle win ) 
{
	FSSpec				spec ;
	OSErr				err;
	
	if ( !GetWinDirty(win) ) return;		// no need to save
		
	spec =  GetWinFSSpec( win ) ;
	
	err = DoWritePICT( spec, GetPictDocPict(win,kOriginal), kCreatorType ) ;
	if (err) return ;						// if err, should do something
	
	SetWinDirty( win, false ) ;
}


void winSaveAsCmndPictDoc ( winHandle win ) 
{
	FSSpec				spec ;
	StandardFileReply	reply ;
	OSErr				err;
	WindowPtr			window ;
	
	spec =  GetWinFSSpec( win ) ;
	StandardPutFile( "\pSave PICT as:", spec.name, &reply);
	
	if ( reply.sfGood )
	{
		spec = reply.sfFile ;
		err = DoWritePICT ( spec, GetPictDocPict(win,kOriginal), kCreatorType ) ;
	}
	
	if (err) return ;						// if err, should do something 
	
	SetWinFSSpec( win, &spec ) ;			// win's spec = new spec
	window = (WindowPtr)GetWinWindow( win ) ;
	SetWTitle( window, spec.name ) ;		// win title = new title
	SetWinDirty( win, false ) ;
}


void winRevertCmndPictDoc ( winHandle win ) 
{	
	// ask user if it's ok
	// cloase w/o save
	// reopen
}


void winPageSetupCmndPictDoc ( winHandle win ) 
{
	OSErr		theErr ;
	
	HiliteMenu(0);		// Unhighlight whatever MenuSelect or MenuKey hilited
	AdjustMenusForPrinting();
	
	if( win != nil )
	{
//		char theState = HGetState( (Handle)win ) ;
//		MoveHHi( (Handle)win ) ;
//		HLock( (Handle)win ) ;
		
		if( !gQDGX_available ) 
		{
			// if GX is not installed then do the classic page setup dialog
			DoStyleDlog( GetWinPrintRec(win) ) ;
		}
		else
		{
			// handle the GX case page setup dialog
			theErr = DoGXStyleDlog( GetWinGXJob(win) ) ;
		} 
//		HSetState( (Handle)win, theState ) ;
	}
}


void winPrintCmndPictDoc ( winHandle win ) 
{
	FSSpec		ourFile ;
	OSErr		theErr ;
	
	HiliteMenu(0);		// Unhighlight whatever MenuSelect or MenuKey hilited
	AdjustMenusForPrinting();

	if( win != nil )
	{
//		char theState = HGetState( (Handle)win ) ;
//		MoveHHi( (Handle)win ) ;
//		HLock( (Handle)win ) ;
			
		if( !gQDGX_available ) 
		{
			// if GX is not installed then do the classic page setup dialog
			theErr = DoJobDlog( GetWinPrintRec(win) ) ; 
		}
		else
		{
			// handle the gx page setup dialog
			theErr = DoGXJobDlog( GetWinGXJob(win) ) ;
		}

//		HSetState( (Handle)win, theState ) ;
		if( theErr == noErr )
		{
			ourFile = GetWinFSSpec( win );
			SetUpCursors(121, 153);
			SendPrintDoc(&ourFile) ;
			TearDownCursors();
			SetCursor(&(qd.arrow)) ;
		}
	}
}


void winPrintOneCmndPictDoc ( winHandle win ) 
{
	FSSpec		ourFile ;
	
	// we can just issue a print command, because we have a valid print record for the 
	// document.  This is in the dPrintRec record of the document record, we created
	// it (or read it in from the document's file) at the time we created the window.
	//
	// for more information on this look at the routines SetupPrintHdl() and LoadPHdl()

	if( win != nil )
	{
		ourFile = GetWinFSSpec(win) ;
		SendPrintDoc(&ourFile) ;
	}
}

