
#ifndef _WINDOWPROFLIST_
#define _WINDOWPROFLIST_


#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __LISTS__
#include <Lists.h>
#endif

#ifndef __CMAPPLICATION__
#include <CMApplication.h>
#endif

#ifndef __CMICCPROFILE__
#include <CMICCProfile.h>
#endif

#ifndef _WIN_
#include "win.h"
#endif


/**\
|**| ==============================================================================
|**| PUBLIC DEFINES
|**| ==============================================================================
\**/
#define kProfListType			'PLst'			// about window tag


/**\
|**| ==============================================================================
|**| PUBLIC TYPEDEFS
|**| ==============================================================================
\**/
typedef struct ProfListData
{
	ListHandle			List ;
	unsigned long		Count ;
	CMProfileSearchRef	SearchResult ;

} ProfListDataRec, *ProfListDataPtr, **ProfListDataHdl ;


/**\
|**| ==============================================================================
|**| PUBLIC FUNCTION PROTOTYPES
|**| ==============================================================================
\**/
void		winActivateProfList		( winHandle win, Boolean becomingActive ) ;
void		winUpdateProfList		( winHandle win, EventRecord *e ) ;
void		winClickProfList		( winHandle win, EventRecord *e ) ;
void		winResizeProfList		( winHandle win ) ;
void		winMenuProfList			( winHandle win, long menuResult ) ;
OSErr		winAllocProfList		( winHandle win ) ;
OSErr		winNewProfList			( winHandle win ) ;
void		winCloseProfList		( winHandle win ) ;
void		winDisposeProfList		( winHandle win ) ;


#endif