// A profile listwindow
//
// David Hayward 
// Developer Technical Support
// AppleLink: DEVSUPPORT
//
// Copyrite 1995, Apple Computer,Inc
//
// This file contains the menus routines for a profile list window.
// 
// 12/13/94	david	first cut


#include "appMenus.h"
#include "aeSenders.h"

#include "win.h"
#include "winProfile.h"
#include "winProfListMenus.h"
#include "winProfListGetSet.h"
#include "winPictDocGetSet.h"



void winAdjustMenusProfList ( winHandle win ) 
{
	MenuHandle	theMenu ;
	short		count ;
	
	// do the file menu
	theMenu = GetMHandle ( mFile ) ;

		EnableItem ( theMenu, 0 );
		EnableItem ( theMenu, iClose );
		
	// do the profiles menu
	theMenu = GetMHandle ( mProfiles ) ;
		count = FindWinHandle( nil, kPictDocType, 1, 1, nil ) ;
	 	if ( count>0 ) 
		{
			ListHandle		list ;
			Point			cell = {0,0} ;
			unsigned long	index ;
			OSType			subtype ;
			
			list = GetProfListList( win ) ;
			
			if ( LGetSelect(true, &cell, list))			// if we can fine one selected item
			{
				index = cell.v ;
				subtype = (index==0)?(kSysProfSubType):(kFileSubType) ;
				
				LNextCell( false, true, &cell, list ) ;
				
				if ( !LGetSelect(true, &cell, list) )	// but we can't find a second item
				{										// then enable the following items
					EnableItem ( theMenu, 0 );
					EnableItem ( theMenu, iMakeSrceProf );
					EnableItem ( theMenu, iMakeDestProf );
					EnableItem ( theMenu, iMakePrevProf );
					if ( subtype!=kSysProfSubType )
					EnableItem ( theMenu, iMakeEmbdProf );
				}
			}
		}

	DrawMenuBar() ;
}


void ProfListMakeProfileCmnd ( winHandle win, short which ) 
{
	winHandle			pictWin ;
	short				count ;
	OSType				subtype ;
	ListHandle			list ;
	Point				cell = {0,0} ;
	CMProfileRef		prof ;
	CMProfileSearchRef	search ;
	unsigned long		index ;
	OSErr				err ;
	
	count = FindWinHandle( nil, kPictDocType, 1, 1, &pictWin ) ;
 	if ( count==0 ) return ;
	
	list = GetProfListList( win ) ;
			
	if ( LGetSelect(true, &cell, list))
	{
		index = cell.v ;
		subtype = (index==0)?(kSysProfSubType):(kFileSubType) ;
		if ( subtype==kFileSubType  )
		{
			search = GetProfListSearchResult( win ) ;
			err = CMSearchGetIndProfile( search, index, &prof ) ;
			SetPictDocProfile( pictWin, which, prof ) ;
			CMCloseProfile( prof ) ;
		}
		else if ( subtype==kSysProfSubType )
			SetPictDocProfile( pictWin, which, nil ) ;
	}
}


void ProfListMakeEmbededCmnd ( winHandle win ) 
{
	winHandle			pictWin ;
	short				count ;
	OSType				subtype ;
	ListHandle			list ;
	Point				cell = {0,0} ;
	CMProfileRef		prof ;
	CMProfileSearchRef	search ;
	unsigned long		index ;
	OSErr				err ;
	
	count = FindWinHandle( nil, kPictDocType, 1, 1, &pictWin ) ;
 	if ( count==0 ) return ;
	
	list = GetProfListList( win ) ;
			
	if ( LGetSelect(true, &cell, list))
	{
		index = cell.v ;
		subtype = (index==0)?(kSysProfSubType):(kFileSubType) ;
		if ( subtype==kFileSubType  )
		{
			search = GetProfListSearchResult( win ) ;
			err = CMSearchGetIndProfile( search, index, &prof ) ;
			err = SetPictDocEmbdProf( pictWin, prof ) ;
			CMCloseProfile( prof ) ;
		}
	}
}
