// A profile window
//
// David Hayward 
// Developer Technical Support
// AppleLink: DEVSUPPORT
//
// Copyrite 1995, Apple Computer,Inc
//
// This file contains the menus routines for a profile window.
// 
// 12/13/94	david	first cut


#include "appMenus.h"

#include "win.h"
#include "winProfile.h"
#include "winProfileGetSet.h"
#include "winProfileMenus.h"
#include "winPictDoc.h"
#include "winPictDocGetSet.h"



void winAdjustMenusProfile ( winHandle win ) 
{
	MenuHandle		theMenu ;
	short			count ;
	OSType			subtype ;
	
	// do the file menu
	theMenu = GetMHandle ( mFile ) ;

		EnableItem ( theMenu, 0 );
		EnableItem ( theMenu, iClose );
	
	// do the profiles menu
	theMenu = GetMHandle ( mProfiles ) ;
		count = FindWinHandle( nil, kPictDocType, 1, 1, nil ) ;
	 	if ( count>0 ) 
		{
			subtype = GetProfileSubType( win ) ;
			EnableItem ( theMenu, 0 );
			EnableItem ( theMenu, iMakeSrceProf );
			EnableItem ( theMenu, iMakeDestProf );
			EnableItem ( theMenu, iMakePrevProf );
			if ( subtype!=kSysProfSubType )
			EnableItem ( theMenu, iMakeEmbdProf );
		}
	
	DrawMenuBar() ;
}


void ProfMakeProfileCmnd ( winHandle win, short which ) 
{
	winHandle		pictWin ;
	short			count ;
	OSType			subtype ;

	count = FindWinHandle( nil, kPictDocType, 1, 1, &pictWin ) ;
 	if ( count==0 ) return ;
	
	subtype = GetProfileSubType( win ) ;
	if ( subtype==kFileSubType || subtype==kEmbededSubType )
		SetPictDocProfile( pictWin, which, GetProfileRef(win) ) ;
	else if ( subtype==kSysProfSubType )
		SetPictDocProfile( pictWin, which, nil ) ;
}

void ProfMakeEmbededCmnd ( winHandle win ) 
{
	winHandle			pictWin ;
	short				count ;
	OSType				subtype ;
	OSErr				err ;
	
	count = FindWinHandle( nil, kPictDocType, 1, 1, &pictWin ) ;
 	if ( count==0 ) return ;
	
	subtype = GetProfileSubType( win ) ;
	if ( subtype==kFileSubType || subtype==kEmbededSubType )
		err = SetPictDocEmbdProf( pictWin, GetProfileRef(win) ) ;
}
